package no.ntnu.cerebrum.medulla;

import no.ntnu.cerebrum.medulla.config.Config;
import org.apache.log4j.PropertyConfigurator;
import org.nd4j.jita.conf.CudaEnvironment;
import org.nd4j.linalg.factory.Nd4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created 2016-09-20.
 * <p>
 * cerebrum-medulla is licenced under the MIT licence.
 */
public class Main {
    public static final String version = "1.33.7";
    public static String hostname;
    public static final int RNG_SEED = 1349;


    public static Logger log = LoggerFactory.getLogger(Main.class);

    public static void main(String[] args) {
        // Verify that configuration files are present, or create from defaults.
        Config.bootstrapConfigurationFiles();
        PropertyConfigurator.configure("config/log4j.properties");

        log.info(String.format("Starting Cerebrum Medulla v%s ...", Main.version));
        Nd4j.ENFORCE_NUMERICAL_STABILITY = true;

        // CUDA config
        if (Config.getBoolean("no.ntnu.cerebrum.medulla.nd4j.useCuda")) {
            CudaEnvironment.getInstance().getConfiguration().allowMultiGPU(true);
        }

        TaskSelector.main(args);
    }
}
