package no.ntnu.cerebrum.medulla.data;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created 2017-03-24.
 * <p>
 * cerebrum-medulla is licenced under the MIT licence.
 */
public class CSV {
    public static Logger log = LoggerFactory.getLogger(CSV.class);

    public static String fromDouble(double[] data) {
        StringBuilder sb = new StringBuilder();

        for (int i = 0; i < data.length; i++) {
            sb.append(data[i]);
            if (i < data.length - 1) sb.append(",");
        }

        sb.append("\n");

        return sb.toString();
    }

    public static String fromDouble(double[][] data) {
        StringBuilder sb = new StringBuilder();
        for (double[] d : data) sb.append(fromDouble(d));
        return sb.toString();
    }

    public static void writeToFile(String fileName, double[] data) {
        if (Storage.writeCSV(fileName, fromDouble(data))) {
            log.info("Dumped data to " + fileName);
        } else {
            log.error("Failed to dump data to " + fileName);
        }
    }

    public static void writeToFile(String fileName, double[][] data) {
        if (Storage.writeCSV(fileName, fromDouble(data))) {
            log.info("Dumped data to " + fileName);
        } else {
            log.error("Failed to dump data to " + fileName);
        }
    }
}
