package no.ntnu.cerebrum.medulla.data;

import com.google.gson.JsonObject;
import no.ntnu.cerebrum.medulla.serializers.GenotypeSerializer;
import no.ntnu.cerebrum.medulla.smcgp.Genotype2;

import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class GraphStorage {
    private static final String GENOTYPE_PATH = Storage.BASE_PATH + Storage.CANDIDATES;

    public static void storeGenotype(Genotype2 genotype2, @Nullable double[] lastResults) {
        String json = GenotypeSerializer.serializeGenotype(genotype2, lastResults).toString();
    }

    public static void writeGenotypeJsonToFile(String fileName, JsonObject serializedData) {
        if (!Storage.writeJSON(fileName, serializedData.toString())) {
            System.err.println("Failed to store genotype!");
        }
    }

    public static void writeGenotypeJsonToFile(GenotypeEnum type, String fileName, JsonObject serializedData) {
        if (!Storage.writeJSON(type.toString() + "/" + fileName, serializedData.toString())) {
            System.err.println("Failed to store genotype!");
        }

    }

    public static List<Genotype2> readStoredGenotypesOfType(GenotypeEnum type) {
        String dir = GENOTYPE_PATH + type.toString() + "/";
        return readStoredGenotypes(dir);
    }

    public static List<Genotype2> readAllStoredGenotypes() {
        return readStoredGenotypes(GENOTYPE_PATH);
    }

    private static List<Genotype2> readStoredGenotypes(String path) {
        return Storage.readAllFiles(path).stream()
            .map(GenotypeSerializer::deserializeGenotype)
            .collect(Collectors.toList());
    }
}
