package no.ntnu.cerebrum.medulla.serializers;


import java.util.HashMap;
import java.util.Map;

public class ConfigTypeSerializer {
    
    public static Map<String, Object> serialize(Map config) {
        Map<String, Object> typedConfig = new HashMap<>();

        for (Object key : config.keySet()) {
            typedConfig.put(key.toString(), convert(config.get(key)));
        }

        return typedConfig;
    }

    private static Object convert(Object o) {
        if (isInt(o)) {
            return Integer.parseInt(o.toString());
        } else if (isDouble(o)) {
            return Double.parseDouble(o.toString());
        } else if (isBool(o)) {
            return Boolean.parseBoolean(o.toString());
        } else {
            return o.toString();
        }
    }


    private static boolean isInt(Object o) {
        if (o.toString().contains(".")) return false;

        try {
            Integer.parseInt(o.toString());
            return true;
        } catch (NumberFormatException e) {
            return false;
        }

    }

    private static boolean isBool(Object o) {
        if (o.toString().equals("true") || o.toString().equals("false")){
            return true;
        }
        return false;
    }

    private static boolean isDouble(Object o) {
        try {
            Double.parseDouble(o.toString());
            return true;
        } catch (NumberFormatException e) {
            return false;
        }
    }
}
