package no.ntnu.cerebrum.medulla.smcgp.graph.action.mathematical;

import no.ntnu.cerebrum.medulla.smcgp.graph.action.Function;
import org.slf4j.Logger;

public class Pow extends Function {

    protected static Logger log = org.slf4j.LoggerFactory.getLogger(Pow.class);

    @Override
    public Object doFunction(double[] inputs, double[] node) {
        if (inputs[1] <= 0) {
            return 1.0;
        } else if (inputs[0] <= 0) {
            return 0.0;
        }

        double result = Math.pow(inputs[0], inputs[1]);

        if (Double.isInfinite(result)) {
            log.debug("Pow result was INFINITE, changing from pow(input1, input2) -> pow(input, 2)");
            return Math.min(Math.pow(inputs[0], 2), Math.pow(inputs[1], 2));
        } else {
            return result;
        }
    }
}
