package no.ntnu.cerebrum.medulla.smcgp.graph.action.selfmodifying;

import no.ntnu.cerebrum.medulla.smcgp.graph.action.SMFunction;

public class SMchc extends SMFunction {

    @Override
    public Object doSMFunction(double[][] graph, double[] activatedNode, int position) {
        // Node to change - P0
        int nodeIndex = inBounds(getParameter(activatedNode, 0), graph.length);

        // parameter to change P1 mod 2
        int connectionToChange = Math.abs(getParameter(activatedNode, 1) % 2) + 1;

        // Value of the new connection, guard against self connection
        int newConnection = Math.max(1, inBounds(getParameter(activatedNode, 2), graph.length));

        double[] changee = graph[nodeIndex];
        changee[connectionToChange] = newConnection;
        graph[connectionToChange] =  changee;

        return graph;
    }
}
