package no.ntnu.cerebrum.medulla.smcgp.graph.action.selfmodifying;

import no.ntnu.cerebrum.medulla.config.Config;
import no.ntnu.cerebrum.medulla.smcgp.graph.action.FunctionLookup;
import no.ntnu.cerebrum.medulla.smcgp.graph.action.SMFunction;
import org.apache.log4j.Logger;

public class SMchf extends SMFunction {
    @Override
    public Object doSMFunction(double[][] graph, double[] activatedNode, int position) {
        int newFunction = Math.abs(getParameter(activatedNode, 1));
        int nodeToChange = inBounds(getParameter(activatedNode, 0), graph.length);

        if (Config.getDouble("no.ntnu.cerebrum.medulla.smcgp.realnumbersUpper") < FunctionLookup.getOpRange()[1]) {
            Logger.getLogger(this.getClass()).warn("Configuration mismatch! realnumbersUpper should be the same as used mathematical and SM functions!");
        }

        graph[nodeToChange][0] = Math.max(Math.min(newFunction, FunctionLookup.getOpRange()[1]), 0);

        return graph;
    }
}
