package no.ntnu.cerebrum.medulla.smcgp.graph.action.selfmodifying;

import no.ntnu.cerebrum.medulla.smcgp.graph.action.SMFunction;
import org.apache.commons.lang.ArrayUtils;

import java.util.Arrays;

public class SMdel extends SMFunction {


    @Override
    public Object doSMFunction(double[][] graph, double[] activatedNode, int position) {
        int p0 = getParameter(activatedNode, 0);
        int p1 = getParameter(activatedNode, 1);
        int p2 = getParameter(activatedNode, 2);

        int from = inBounds(p0 + position, graph.length); // p0 + x
        int to = inBounds(p0 + position + p1, graph.length); // p0 + x + p1
        int noToRemove = to - from;

        if (noToRemove > 0) {
            double[][] first = Arrays.copyOfRange(graph, 0, from);
            double[][] second = Arrays.copyOfRange(graph, to, graph.length);
            return ArrayUtils.addAll(first, second);
        }

        logging(this, String.format("removing nodes between [%s] and [%s]", from, to));

        return graph;
    }

}
