package no.ntnu.cerebrum.medulla.smcgp.graph.action.selfmodifying;

import no.ntnu.cerebrum.medulla.config.Config;
import no.ntnu.cerebrum.medulla.smcgp.graph.action.SMFunction;

public class SMmov extends SMFunction {
    @Override
    public Object doSMFunction(double[][] graph, double[] activatedNode, int position) {
        int p0 = getParameter(activatedNode, 0);
        int p1 = getParameter(activatedNode, 1);
        int p2 = getParameter(activatedNode, 2);

        int from = inBounds(p0 + position, graph.length); // p0 + x
        int to = inBounds(from + p1, graph.length); // p0 + x + p1
        int insertAfter = inBounds(from + p2, graph.length); // p0 + x + p2

        if (to > from) {
            // Place an upper limit to the amount of nodes that can be moved each iteration
            int maxMov = Config.getInt("no.ntnu.cerebrum.medulla.smcgp.maxNodesMovedOrDuplicated");
            if (to - from > maxMov) to = from + maxMov;

            // Iterate over the nodes to be moved, and swap them in-place one by one...
            for (int i = to - from - 1; i >= 0; i--) {
                int fromIndex = Math.min(from + i, graph.length - 1);
                int toIndex = Math.min(insertAfter + i + 1, graph.length - 1);

                double[] geneToMove = graph[fromIndex];

                graph[fromIndex] = graph[toIndex];
                graph[toIndex] = geneToMove;
            }
        }

        return graph;
    }
}
