package no.ntnu.cerebrum.medulla.smcgp.graph.action.selfmodifying;

import no.ntnu.cerebrum.medulla.smcgp.graph.action.SMFunction;

public class SMshiftc extends SMFunction {

    @Override
    public Object doSMFunction(double[][] graph, double[] activatedNode, int position) {
        // Node to change - P0
        int nodeIndex = inBounds(getParameter(activatedNode, 0) + position, graph.length);

        // Shift connections by
        int shiftAmount = getParameter(activatedNode, 2);

        // New connection values
        double newConnectionI = graph[nodeIndex][1] + shiftAmount;
        double newConnectionJ = graph[nodeIndex][2] + shiftAmount;

        // Break if out of bounds, preventing unnecessary state changes that have no e
        newConnectionI = Math.min(Math.max(newConnectionI, 1), graph.length);
        newConnectionJ = Math.min(Math.max(newConnectionJ, 1), graph.length);

        // Set new values
        double[] changed = graph[nodeIndex];
        changed[1] = newConnectionI;
        changed[2] = newConnectionJ;
        graph[nodeIndex] = changed;

        return graph;
    }
}

